searchNodes=[{"doc":"HTTP2-compliant wrapper for sending iOS and Android push notifications.","ref":"Pigeon.html","title":"Pigeon","type":"module"},{"doc":"","ref":"Pigeon.html#debug_log?/0","title":"Pigeon.debug_log?/0","type":"function"},{"doc":"Returns the configured JSON encoding library for Pigeon. To customize the JSON library, include the following in your config/config.exs: config :pigeon, :json_library, Jason","ref":"Pigeon.html#json_library/0","title":"Pigeon.json_library/0","type":"function"},{"doc":"Amazon Device Messaging (ADM)","ref":"Pigeon.ADM.html","title":"Pigeon.ADM","type":"module"},{"doc":"Sends a push over ADM. Examples iex&gt; msg = %{&quot;body&quot; =&gt; &quot;your message&quot;} iex&gt; n = Pigeon.ADM.Notification.new(&quot;your_reg_id&quot;, msg) iex&gt; Pigeon.ADM.push(n, on_response: nil) :ok iex&gt; msg = %{&quot;body&quot; =&gt; &quot;your message&quot;} iex&gt; n = Pigeon.ADM.Notification.new(&quot;your_reg_id&quot;, msg) iex&gt; Pigeon.ADM.push(n) %Pigeon.ADM.Notification{consolidation_key: nil, expires_after: 604800, md5: &quot;M13RuG4uDWqajseQcCiyiw==&quot;, payload: %{&quot;data&quot; =&gt; %{&quot;body&quot; =&gt; &quot;your message&quot;}}, registration_id: &quot;your_reg_id&quot;, response: :invalid_registration_id, updated_registration_id: nil} iex&gt; msg = %{&quot;body&quot; =&gt; &quot;your message&quot;} iex&gt; n = Pigeon.ADM.Notification.new(&quot;your_reg_id&quot;, msg) iex&gt; notifs = Pigeon.ADM.push([n, n], to: :adm_default) iex&gt; Enum.map(notifs, &amp; &amp;1.response) [:invalid_registration_id, :invalid_registration_id] iex&gt; me = self() iex&gt; handler = fn(_x) -&gt; send(me, &quot;Sent a push!&quot;) end iex&gt; n = Pigeon.ADM.Notification.new(&quot;your_reg_id&quot;, %{}) iex&gt; Pigeon.ADM.push(n, on_response: handler) iex&gt; receive do ...&gt; x -&gt; x ...&gt; after ...&gt; 5_000 -&gt; &quot;No push response...&quot; ...&gt; end &quot;Sent a push!&quot; iex&gt; msg = %{&quot;body&quot; =&gt; &quot;your message&quot;} iex&gt; n = Pigeon.ADM.Notification.new(&quot;your_reg_id&quot;, msg) iex&gt; notif = Pigeon.ADM.push(n, to: :worker_not_started) iex&gt; notif.response :timeout","ref":"Pigeon.ADM.html#push/2","title":"Pigeon.ADM.push/2","type":"function"},{"doc":"Starts ADM worker connection with given config or name. Examples iex&gt; config = Pigeon.ADM.Config.new(:adm_default) iex&gt; {:ok, pid} = Pigeon.ADM.start_connection(%{config | name: nil}) iex&gt; Process.alive?(pid) true","ref":"Pigeon.ADM.html#start_connection/1","title":"Pigeon.ADM.start_connection/1","type":"function"},{"doc":"Stops existing ADM worker connection. Examples iex&gt; config = Pigeon.ADM.Config.new(:adm_default) iex&gt; {:ok, pid} = Pigeon.ADM.start_connection(%{config | name: nil}) iex&gt; Pigeon.ADM.stop_connection(pid) :ok iex&gt; :timer.sleep(500) iex&gt; Process.alive?(pid) false","ref":"Pigeon.ADM.html#stop_connection/1","title":"Pigeon.ADM.stop_connection/1","type":"function"},{"doc":"","ref":"Pigeon.ADM.html#t:connection_response/0","title":"Pigeon.ADM.connection_response/0","type":"type"},{"doc":"Async callback for push notifications response. Examples handler = fn(%Pigeon.ADM.Notification{response: response}) -&gt; case response do :success -&gt; Logger.debug &quot;Push successful!&quot; :unregistered -&gt; Logger.error &quot;Bad device token!&quot; _error -&gt; Logger.error &quot;Some other error happened.&quot; end end n = Pigeon.ADM.Notification.new(&quot;token&quot;, %{&quot;message&quot; =&gt; &quot;test&quot;}) Pigeon.ADM.push(n, on_response: handler)","ref":"Pigeon.ADM.html#t:on_response/0","title":"Pigeon.ADM.on_response/0","type":"type"},{"doc":"Options for sending push notifications. :to - Defines worker to process push. Defaults to :adm_default :on_response - Optional async callback triggered on receipt of push. See on_response/0","ref":"Pigeon.ADM.html#t:push_opts/0","title":"Pigeon.ADM.push_opts/0","type":"type"},{"doc":"Validates configuration settings that initialize ADM.Worker instances.","ref":"Pigeon.ADM.Config.html","title":"Pigeon.ADM.Config","type":"module"},{"doc":"","ref":"Pigeon.ADM.Config.html#default_name/0","title":"Pigeon.ADM.Config.default_name/0","type":"function"},{"doc":"Returns a new ADM.Config with given opts. Examples iex&gt; Pigeon.ADM.Config.new( ...&gt; name: :test, ...&gt; client_id: &quot;amzn.client.id&quot;, ...&gt; client_secret: &quot;1234secret&quot; ...&gt; ) %Pigeon.ADM.Config{name: :test, client_id: &quot;amzn.client.id&quot;, client_secret: &quot;1234secret&quot;}","ref":"Pigeon.ADM.Config.html#new/1","title":"Pigeon.ADM.Config.new/1","type":"function"},{"doc":"Returns whether a given config has valid credentials. Examples iex&gt; :adm_default |&gt; new() |&gt; valid?() true","ref":"Pigeon.ADM.Config.html#valid?/1","title":"Pigeon.ADM.Config.valid?/1","type":"function"},{"doc":"","ref":"Pigeon.ADM.Config.html#validate!/1","title":"Pigeon.ADM.Config.validate!/1","type":"function"},{"doc":"","ref":"Pigeon.ADM.Config.html#t:t/0","title":"Pigeon.ADM.Config.t/0","type":"type"},{"doc":"Defines Amazon ADM notification struct and convenience constructor functions.","ref":"Pigeon.ADM.Notification.html","title":"Pigeon.ADM.Notification","type":"module"},{"doc":"Creates ADM.Notification struct with device registration ID and optional data payload. Examples iex&gt; Pigeon.ADM.Notification.new(&quot;reg ID&quot;) %Pigeon.ADM.Notification{ consolidation_key: nil, md5: &quot;1B2M2Y8AsgTpgAmY7PhCfg==&quot;, payload: %{&quot;data&quot; =&gt; %{}}, registration_id: &quot;reg ID&quot;, updated_registration_id: nil } iex&gt; Pigeon.ADM.Notification.new(&quot;reg ID&quot;, %{&quot;message&quot; =&gt; &quot;your message&quot;}) %Pigeon.ADM.Notification{ consolidation_key: nil, md5: &quot;qzF+HgArKZjJrpfcTbiFxg==&quot;, payload: %{ &quot;data&quot; =&gt; %{&quot;message&quot; =&gt; &quot;your message&quot;} }, registration_id: &quot;reg ID&quot;, updated_registration_id: nil } iex&gt; Pigeon.ADM.Notification.new(&quot;reg ID&quot;, &quot;not a map&quot;) %Pigeon.ADM.Notification{ consolidation_key: nil, md5: &quot;1B2M2Y8AsgTpgAmY7PhCfg==&quot;, payload: %{&quot;data&quot; =&gt; %{}}, registration_id: &quot;reg ID&quot;, updated_registration_id: nil }","ref":"Pigeon.ADM.Notification.html#new/2","title":"Pigeon.ADM.Notification.new/2","type":"function"},{"doc":"Updates &quot;data&quot; key on push payload and calculates md5 hash. Examples iex&gt; n = %Pigeon.ADM.Notification{} iex&gt; Pigeon.ADM.Notification.put_data(n, %{&quot;message&quot; =&gt; &quot;your message&quot;}) %Pigeon.ADM.Notification{ consolidation_key: nil, md5: &quot;qzF+HgArKZjJrpfcTbiFxg==&quot;, payload: %{ &quot;data&quot; =&gt; %{&quot;message&quot; =&gt; &quot;your message&quot;} }, registration_id: nil, updated_registration_id: nil }","ref":"Pigeon.ADM.Notification.html#put_data/2","title":"Pigeon.ADM.Notification.put_data/2","type":"function"},{"doc":"ADM error responses","ref":"Pigeon.ADM.Notification.html#t:error_response/0","title":"Pigeon.ADM.Notification.error_response/0","type":"type"},{"doc":"ADM push response nil - Push has not been sent yet :success - Push was successfully sent error_response/0 - Push attempted but server responded with error :timeout - Internal error. Push did not reach ADM servers","ref":"Pigeon.ADM.Notification.html#t:response/0","title":"Pigeon.ADM.Notification.response/0","type":"type"},{"doc":"ADM notification Examples %Pigeon.ADM.Notification{ consolidation_key: nil, expires_after: 604_800, md5: &quot;qzF+HgArKZjJrpfcTbiFxg==&quot;, payload: %{ &quot;data&quot; =&gt; %{&quot;message&quot; =&gt; &quot;your message&quot;} }, registration_id: &quot;reg ID&quot;, response: nil, # Set on push response updated_registration_id: nil }","ref":"Pigeon.ADM.Notification.html#t:t/0","title":"Pigeon.ADM.Notification.t/0","type":"type"},{"doc":"Apple Push Notification Service (APNS)","ref":"Pigeon.APNS.html","title":"Pigeon.APNS","type":"module"},{"doc":"Sends a push over APNS. Examples iex&gt; n = Pigeon.APNS.Notification.new(&quot;msg&quot;, &quot;token&quot;, &quot;topic&quot;) iex&gt; Pigeon.APNS.push(n) %Pigeon.APNS.Notification{device_token: &quot;token&quot;, expiration: nil, response: :bad_device_token, id: nil, payload: %{&quot;aps&quot; =&gt; %{&quot;alert&quot; =&gt; &quot;msg&quot;}}, topic: &quot;topic&quot;} iex&gt; n = Pigeon.APNS.Notification.new(&quot;msg&quot;, &quot;token&quot;, &quot;topic&quot;) iex&gt; Pigeon.APNS.push([n, n], on_response: nil) :ok iex&gt; n = Pigeon.APNS.Notification.new(&quot;msg&quot;, &quot;token&quot;, &quot;topic&quot;) iex&gt; Pigeon.APNS.push([n, n]) [%Pigeon.APNS.Notification{device_token: &quot;token&quot;, expiration: nil, response: :bad_device_token, id: nil, payload: %{&quot;aps&quot; =&gt; %{&quot;alert&quot; =&gt; &quot;msg&quot;}}, topic: &quot;topic&quot;}, %Pigeon.APNS.Notification{device_token: &quot;token&quot;, expiration: nil, response: :bad_device_token, id: nil, payload: %{&quot;aps&quot; =&gt; %{&quot;alert&quot; =&gt; &quot;msg&quot;}}, topic: &quot;topic&quot;}]","ref":"Pigeon.APNS.html#push/2","title":"Pigeon.APNS.push/2","type":"function"},{"doc":"Starts APNS worker connection with given config or name. Examples iex&gt; config = Pigeon.APNS.Config.new(:apns_default) iex&gt; {:ok, pid} = Pigeon.APNS.start_connection(%{config | name: nil}) iex&gt; Process.alive?(pid) true","ref":"Pigeon.APNS.html#start_connection/1","title":"Pigeon.APNS.start_connection/1","type":"function"},{"doc":"Stops existing APNS worker connection. Examples iex&gt; config = Pigeon.APNS.Config.new(:apns_default) iex&gt; {:ok, pid} = Pigeon.APNS.start_connection(%{config | name: nil}) iex&gt; Pigeon.APNS.stop_connection(pid) :ok iex&gt; :timer.sleep(500) iex&gt; Process.alive?(pid) false","ref":"Pigeon.APNS.html#stop_connection/1","title":"Pigeon.APNS.stop_connection/1","type":"function"},{"doc":"Can be either a single notification or a list.","ref":"Pigeon.APNS.html#t:notification/0","title":"Pigeon.APNS.notification/0","type":"type"},{"doc":"Async callback for push notification response. Examples handler = fn(%Pigeon.APNS.Notification{response: response}) -&gt; case response do :success -&gt; Logger.debug &quot;Push successful!&quot; :bad_device_token -&gt; Logger.error &quot;Bad device token!&quot; _error -&gt; Logger.error &quot;Some other error happened.&quot; end end n = Pigeon.APNS.Notification.new(&quot;msg&quot;, &quot;device token&quot;, &quot;push topic&quot;) Pigeon.APNS.push(n, on_response: handler)","ref":"Pigeon.APNS.html#t:on_response/0","title":"Pigeon.APNS.on_response/0","type":"type"},{"doc":"Options for sending push notifications. :to - Defines worker to process push. Defaults to :apns_default :on_response - Optional async callback triggered on receipt of push. See on_response/0","ref":"Pigeon.APNS.html#t:push_opts/0","title":"Pigeon.APNS.push_opts/0","type":"type"},{"doc":"Configuration for APNS Workers using certificates.","ref":"Pigeon.APNS.Config.html","title":"Pigeon.APNS.Config","type":"module"},{"doc":"Returns a new APNS.Config with given opts or name. If given an atom, returns the config specified in your config.exs. Examples iex&gt; Pigeon.APNS.Config.new( ...&gt; name: :test, ...&gt; mode: :prod, ...&gt; cert: &quot;test/support/test_cert.pem-mock&quot;, ...&gt; key: &quot;test/support/test_key.pem-mock&quot;, ...&gt; port: 2197, ...&gt; ping_period: 300_000 ...&gt; ) %Pigeon.APNS.Config{uri: &quot;api.push.apple.com&quot;, name: :test, certfile: Path.expand(&quot;test/support/test_cert.pem-mock&quot;), keyfile: Path.expand(&quot;test/support/test_key.pem-mock&quot;), ping_period: 300000, port: 2197, reconnect: false} iex&gt; config = Pigeon.APNS.Config.new(:apns_default) iex&gt; %{config | certfile: nil, keyfile: nil} # Hide for testing iex&gt; match? %_{uri: &quot;api.development.push.apple.com&quot;, ...&gt; name: :apns_default, ping_period: 600_000, port: 443}, config true","ref":"Pigeon.APNS.Config.html#new/1","title":"Pigeon.APNS.Config.new/1","type":"function"},{"doc":"Options for configuring certificate APNS connections. Configuration Options :name - Registered worker name. :mode - If set to :dev or :prod, will set the appropriate :uri :cert - Push certificate. Can be one of three options: Static file path Full-text string of the file contents (useful for environment variables) {:my_app, &quot;certs/cert.pem&quot;} (indicates path relative to the priv folder of the given application) :key - Push private key. Same as :cert :uri - Push server uri. If set, overrides uri defined by :mode. Useful for test environments. :port - Push server port. Can be any value, but APNS only accepts 443 and 2197 :ping_period - Interval between server pings. Necessary to keep long running APNS connections alive. Defaults to 10 minutes. Deprecated Options :reconnect - No longer used as of v1.2.0.","ref":"Pigeon.APNS.Config.html#t:config_opts/0","title":"Pigeon.APNS.Config.config_opts/0","type":"type"},{"doc":"Certificate APNS configuration struct This struct should not be set directly. Instead use new/1 with config_opts/0. Examples %Pigeon.APNS.Config{ name: :apns_default, reconnect: true, cert: nil, certfile: &quot;cert.pem&quot;, key: nil, keyfile: &quot;key.pem&quot;, uri: &quot;api.push.apple.com&quot;, port: 443, ping_period: 600_000 }","ref":"Pigeon.APNS.Config.html#t:t/0","title":"Pigeon.APNS.Config.t/0","type":"type"},{"doc":"Defines APNS error responses","ref":"Pigeon.APNS.Error.html","title":"Pigeon.APNS.Error","type":"module"},{"doc":"If enabled, logs a notification and its error response.","ref":"Pigeon.APNS.Error.html#log/2","title":"Pigeon.APNS.Error.log/2","type":"function"},{"doc":"","ref":"Pigeon.APNS.Error.html#t:error_response/0","title":"Pigeon.APNS.Error.error_response/0","type":"type"},{"doc":"Configuration for APNS Workers using JWT.","ref":"Pigeon.APNS.JWTConfig.html","title":"Pigeon.APNS.JWTConfig","type":"module"},{"doc":"Returns a new APNS.JWTConfig with given opts or name. If given an atom, returns the config specified in your config.exs. Examples iex&gt; Pigeon.APNS.JWTConfig.new( ...&gt; name: :test, ...&gt; mode: :prod, ...&gt; key: &quot;test/support/AuthKey.p8-mock&quot;, ...&gt; key_identifier: &quot;ABC1234567&quot;, ...&gt; team_id: &quot;DEF1234567&quot;, ...&gt; port: 2197, ...&gt; ping_period: 300_000 ...&gt; ) %Pigeon.APNS.JWTConfig{uri: &quot;api.push.apple.com&quot;, name: :test, team_id: &quot;DEF1234567&quot;, key_identifier: &quot;ABC1234567&quot;, keyfile: Path.expand(&quot;test/support/AuthKey.p8-mock&quot;), ping_period: 300000, port: 2197, reconnect: false} iex&gt; config = Pigeon.APNS.JWTConfig.new(:apns_jwt_static) iex&gt; %{config | key: nil, key_identifier: nil, team_id: nil} # Hide for testing iex&gt; match? %_{uri: &quot;api.development.push.apple.com&quot;, name: :apns_jwt_static, ...&gt; ping_period: 600_000, port: 443, reconnect: false}, config true","ref":"Pigeon.APNS.JWTConfig.html#new/1","title":"Pigeon.APNS.JWTConfig.new/1","type":"function"},{"doc":"Options for configuring JWT APNS connections. Configuration Options :name - Registered worker name. :mode - If set to :dev or :prod, will set the appropriate :uri :key - JWT private key. Can be one of three options: Static file path Full-text string of the file contents (useful for environment variables) {:my_app, &quot;keys/private_key.p8&quot;} (indicates path relative to the priv folder of the given application) :key_identifier - A 10-character key identifier (kid) key, obtained from your developer account :team_id - Your 10-character Team ID, obtained from your developer account :uri - Push server uri. If set, overrides uri defined by :mode. Useful for test environments. :port - Push server port. Can be any value, but APNS only accepts 443 and 2197 :ping_period - Interval between server pings. Necessary to keep long running APNS connections alive. Defaults to 10 minutes. Deprecated Options :reconnect - No longer used as of v1.2.0.","ref":"Pigeon.APNS.JWTConfig.html#t:config_opts/0","title":"Pigeon.APNS.JWTConfig.config_opts/0","type":"type"},{"doc":"","ref":"Pigeon.APNS.JWTConfig.html#t:headers/0","title":"Pigeon.APNS.JWTConfig.headers/0","type":"type"},{"doc":"JWT APNS configuration struct This struct should not be set directly. Instead use new/1 with config_opts/0. Examples %Pigeon.APNS.JWTConfig{ name: :apns_default, reconnect: true, uri: &quot;api.push.apple.com&quot;, port: 443, ping_period: 600_000, key: nil, keyfile: &quot;key.p8&quot;, key_identifier: &quot;ABC1234567&quot;, team_id: &quot;DEF1234567&quot; }","ref":"Pigeon.APNS.JWTConfig.html#t:t/0","title":"Pigeon.APNS.JWTConfig.t/0","type":"type"},{"doc":"Defines APNS notification struct and constructor functions.","ref":"Pigeon.APNS.Notification.html","title":"Pigeon.APNS.Notification","type":"module"},{"doc":"Returns an APNS.Notification struct with given message, device token, and topic (optional). Push payload is constructed in the form of %{&quot;aps&quot; =&gt; %{&quot;alert&quot; =&gt; msg}} Examples iex&gt; Pigeon.APNS.Notification.new(&quot;push message&quot;, &quot;device token&quot;) %Pigeon.APNS.Notification{ device_token: &quot;device token&quot;, expiration: nil, priority: nil, push_type: &quot;alert&quot;, id: nil, payload: %{&quot;aps&quot; =&gt; %{&quot;alert&quot; =&gt; &quot;push message&quot;}}, topic: nil }","ref":"Pigeon.APNS.Notification.html#new/3","title":"Pigeon.APNS.Notification.new/3","type":"function"},{"doc":"Returns an APNS.Notification struct with given message, device token, topic, and message ID. Push payload is constructed in the form of %{&quot;aps&quot; =&gt; %{&quot;alert&quot; =&gt; msg}} Examples iex&gt; Pigeon.APNS.Notification.new(&quot;push message&quot;, &quot;device token&quot;, &quot;topic&quot;, &quot;id_1234&quot;) %Pigeon.APNS.Notification{ collapse_id: nil, device_token: &quot;device token&quot;, expiration: nil, priority: nil, push_type: &quot;alert&quot;, id: &quot;id_1234&quot;, payload: %{&quot;aps&quot; =&gt; %{&quot;alert&quot; =&gt; &quot;push message&quot;}}, topic: &quot;topic&quot; }","ref":"Pigeon.APNS.Notification.html#new/4","title":"Pigeon.APNS.Notification.new/4","type":"function"},{"doc":"Updates &quot;alert&quot; key in push payload. This is the alert message displayed on the device. Examples iex&gt; Pigeon.APNS.Notification.put_alert(%Pigeon.APNS.Notification{}, &quot;push message&quot;) %Pigeon.APNS.Notification{ collapse_id: nil, device_token: nil, expiration: nil, priority: nil, push_type: &quot;alert&quot;, id: nil, payload: %{&quot;aps&quot; =&gt; %{&quot;alert&quot; =&gt; &quot;push message&quot;}}, topic: nil }","ref":"Pigeon.APNS.Notification.html#put_alert/2","title":"Pigeon.APNS.Notification.put_alert/2","type":"function"},{"doc":"Updates &quot;badge&quot; key in push payload. This is the badge number displayed on the application. Examples iex&gt; Pigeon.APNS.Notification.put_badge(%Pigeon.APNS.Notification{}, 5) %Pigeon.APNS.Notification{ collapse_id: nil, device_token: nil, expiration: nil, priority: nil, push_type: &quot;alert&quot;, id: nil, payload: %{&quot;aps&quot; =&gt; %{&quot;badge&quot; =&gt; 5}}, topic: nil }","ref":"Pigeon.APNS.Notification.html#put_badge/2","title":"Pigeon.APNS.Notification.put_badge/2","type":"function"},{"doc":"Updates &quot;category&quot; key in push payload. Examples iex&gt; Pigeon.APNS.Notification.put_category(%Pigeon.APNS.Notification{}, &quot;category&quot;) %Pigeon.APNS.Notification{ collapse_id: nil, device_token: nil, expiration: nil, priority: nil, push_type: &quot;alert&quot;, id: nil, payload: %{&quot;aps&quot; =&gt; %{&quot;category&quot; =&gt; &quot;category&quot;}}, topic: nil }","ref":"Pigeon.APNS.Notification.html#put_category/2","title":"Pigeon.APNS.Notification.put_category/2","type":"function"},{"doc":"Sets &quot;content-available&quot; flag in push payload. Used for silent notifications. When set, ensure alert, badge, and sound keys are not configured. Examples iex&gt; Pigeon.APNS.Notification.put_content_available(%Pigeon.APNS.Notification{}) %Pigeon.APNS.Notification{ collapse_id: nil, device_token: nil, expiration: nil, priority: nil, push_type: &quot;alert&quot;, id: nil, payload: %{&quot;aps&quot; =&gt; %{&quot;content-available&quot; =&gt; 1}}, topic: nil }","ref":"Pigeon.APNS.Notification.html#put_content_available/1","title":"Pigeon.APNS.Notification.put_content_available/1","type":"function"},{"doc":"Puts custom data in push payload. Examples iex&gt; n = Pigeon.APNS.Notification.new(&quot;test message&quot;, &quot;device token&quot;) iex&gt; Pigeon.APNS.Notification.put_custom(n, %{&quot;custom-key&quot; =&gt; 1234}) %Pigeon.APNS.Notification{ collapse_id: nil, device_token: &quot;device token&quot;, expiration: nil, priority: nil, push_type: &quot;alert&quot;, id: nil, payload: %{&quot;aps&quot; =&gt; %{&quot;alert&quot; =&gt; &quot;test message&quot;}, &quot;custom-key&quot; =&gt; 1234}, topic: nil }","ref":"Pigeon.APNS.Notification.html#put_custom/2","title":"Pigeon.APNS.Notification.put_custom/2","type":"function"},{"doc":"Sets &quot;mutable-content&quot; flag in push payload. Used for notification service extensions (such as displaying custom media). Examples iex&gt; Pigeon.APNS.Notification.put_mutable_content(%Pigeon.APNS.Notification{}) %Pigeon.APNS.Notification{ collapse_id: nil, device_token: nil, expiration: nil, priority: nil, push_type: &quot;alert&quot;, id: nil, payload: %{&quot;aps&quot; =&gt; %{&quot;mutable-content&quot; =&gt; 1}}, topic: nil }","ref":"Pigeon.APNS.Notification.html#put_mutable_content/1","title":"Pigeon.APNS.Notification.put_mutable_content/1","type":"function"},{"doc":"Updates &quot;sound&quot; key in push payload. Used for custom notification sounds. Value should be the name of the custom sound file in the application&#39;s binary. Examples iex&gt; Pigeon.APNS.Notification.put_sound(%Pigeon.APNS.Notification{}, &quot;custom.aiff&quot;) %Pigeon.APNS.Notification{ collapse_id: nil, device_token: nil, expiration: nil, priority: nil, push_type: &quot;alert&quot;, id: nil, payload: %{&quot;aps&quot; =&gt; %{&quot;sound&quot; =&gt; &quot;custom.aiff&quot;}}, topic: nil }","ref":"Pigeon.APNS.Notification.html#put_sound/2","title":"Pigeon.APNS.Notification.put_sound/2","type":"function"},{"doc":"APNS push response nil - Push has not been sent yet. :success - Push was successfully sent. Pigeon.APNS.Error.error_response/0 - Push attempted but server responded with error. :timeout - Internal error. Push did not reach APNS servers.","ref":"Pigeon.APNS.Notification.html#t:response/0","title":"Pigeon.APNS.Notification.response/0","type":"type"},{"doc":"APNS notification Examples %Pigeon.APNS.Notification{ collapse_id: nil, device_token: &quot;device token&quot;, expiration: nil, priority: nil, push_type: &quot;alert&quot;, id: nil, # Set on push response if nil payload: %{&quot;aps&quot; =&gt; %{&quot;alert&quot; =&gt; &quot;push message&quot;}}, response: nil, # Set on push response topic: &quot;com.example.YourApp&quot; }","ref":"Pigeon.APNS.Notification.html#t:t/0","title":"Pigeon.APNS.Notification.t/0","type":"type"},{"doc":"","ref":"Pigeon.Configurable.html","title":"Pigeon.Configurable","type":"protocol"},{"doc":"","ref":"Pigeon.Configurable.html#close/1","title":"Pigeon.Configurable.close/1","type":"function"},{"doc":"","ref":"Pigeon.Configurable.html#connect/1","title":"Pigeon.Configurable.connect/1","type":"function"},{"doc":"","ref":"Pigeon.Configurable.html#handle_end_stream/4","title":"Pigeon.Configurable.handle_end_stream/4","type":"function"},{"doc":"","ref":"Pigeon.Configurable.html#max_demand/1","title":"Pigeon.Configurable.max_demand/1","type":"function"},{"doc":"","ref":"Pigeon.Configurable.html#push_headers/3","title":"Pigeon.Configurable.push_headers/3","type":"function"},{"doc":"","ref":"Pigeon.Configurable.html#push_payload/3","title":"Pigeon.Configurable.push_payload/3","type":"function"},{"doc":"Schedules connection ping if necessary. Examples iex&gt; schedule_ping(%Pigeon.APNS.Config{ping_period: 2}) iex&gt; receive do ...&gt; :ping -&gt; &quot;Got ping!&quot; ...&gt; after ...&gt; 5000 -&gt; &quot;No ping received.&quot; ...&gt; end &quot;Got ping!&quot; iex&gt; schedule_ping(%Pigeon.FCM.Config{}) iex&gt; receive do ...&gt; :ping -&gt; &quot;Got ping!&quot; ...&gt; after ...&gt; 5000 -&gt; &quot;No ping received.&quot; ...&gt; end &quot;No ping received.&quot;","ref":"Pigeon.Configurable.html#schedule_ping/1","title":"Pigeon.Configurable.schedule_ping/1","type":"function"},{"doc":"","ref":"Pigeon.Configurable.html#validate!/1","title":"Pigeon.Configurable.validate!/1","type":"function"},{"doc":"Returns worker name for config. Examples iex&gt; worker_name(%Pigeon.APNS.Config{name: :test}) :test iex&gt; worker_name(%Pigeon.FCM.Config{name: :another}) :another","ref":"Pigeon.Configurable.html#worker_name/1","title":"Pigeon.Configurable.worker_name/1","type":"function"},{"doc":"","ref":"Pigeon.Configurable.html#t:sock/0","title":"Pigeon.Configurable.sock/0","type":"type"},{"doc":"","ref":"Pigeon.Configurable.html#t:t/0","title":"Pigeon.Configurable.t/0","type":"type"},{"doc":"","ref":"Pigeon.Encodable.html","title":"Pigeon.Encodable","type":"protocol"},{"doc":"","ref":"Pigeon.Encodable.html#binary_payload/1","title":"Pigeon.Encodable.binary_payload/1","type":"function"},{"doc":"","ref":"Pigeon.Encodable.html#t:t/0","title":"Pigeon.Encodable.t/0","type":"type"},{"doc":"Firebase Cloud Messaging (FCM)","ref":"Pigeon.FCM.html","title":"Pigeon.FCM","type":"module"},{"doc":"Sends a push over FCM. Examples iex&gt; n = Pigeon.FCM.Notification.new(&quot;regId&quot;, %{}, %{&quot;message&quot; =&gt; &quot;123&quot;}) iex&gt; Pigeon.FCM.push(n) %Pigeon.FCM.Notification{message_id: nil, payload: %{&quot;data&quot; =&gt; %{&quot;message&quot; =&gt; &quot;123&quot;}}, priority: :normal, registration_id: &quot;regId&quot;, status: :success, response: [invalid_registration: &quot;regId&quot;]} iex&gt; n = Pigeon.FCM.Notification.new(&quot;regId&quot;, %{}, %{&quot;message&quot; =&gt; &quot;123&quot;}) iex&gt; Pigeon.FCM.push(n, on_response: nil) :ok iex&gt; n = Pigeon.FCM.Notification.new([&quot;regId&quot;, &quot;regId&quot;], %{}, ...&gt; %{&quot;message&quot; =&gt; &quot;123&quot;}) iex&gt; Pigeon.FCM.push(n) %Pigeon.FCM.Notification{message_id: nil, payload: %{&quot;data&quot; =&gt; %{&quot;message&quot; =&gt; &quot;123&quot;}}, priority: :normal, registration_id: [&quot;regId&quot;, &quot;regId&quot;], status: :success, response: [invalid_registration: &quot;regId&quot;, invalid_registration: &quot;regId&quot;]} iex&gt; n = Pigeon.FCM.Notification.new([&quot;regId&quot;, &quot;regId&quot;], %{}, ...&gt; %{&quot;message&quot; =&gt; &quot;test&quot;}) iex&gt; notifs = Pigeon.FCM.push([n, n]) iex&gt; Enum.map(notifs, &amp; &amp;1.response) [[invalid_registration: &quot;regId&quot;, invalid_registration: &quot;regId&quot;], [invalid_registration: &quot;regId&quot;, invalid_registration: &quot;regId&quot;]]","ref":"Pigeon.FCM.html#push/2","title":"Pigeon.FCM.push/2","type":"function"},{"doc":"Starts FCM worker connection with given config or name. Examples iex&gt; config = Pigeon.FCM.Config.new(:fcm_default) iex&gt; {:ok, pid} = Pigeon.FCM.start_connection(%{config | name: nil}) iex&gt; Process.alive?(pid) true","ref":"Pigeon.FCM.html#start_connection/1","title":"Pigeon.FCM.start_connection/1","type":"function"},{"doc":"Stops existing FCM worker connection. Examples iex&gt; config = Pigeon.FCM.Config.new(:fcm_default) iex&gt; {:ok, pid} = Pigeon.FCM.start_connection(%{config | name: nil}) iex&gt; Pigeon.FCM.stop_connection(pid) :ok iex&gt; :timer.sleep(500) iex&gt; Process.alive?(pid) false","ref":"Pigeon.FCM.html#stop_connection/1","title":"Pigeon.FCM.stop_connection/1","type":"function"},{"doc":"Can be either a single notification or a list.","ref":"Pigeon.FCM.html#t:notification/0","title":"Pigeon.FCM.notification/0","type":"type"},{"doc":"Async callback for push notification response. Examples handler = fn(n) -&gt; case n.status do :success -&gt; bad_regids = FCM.Notification.remove?(n) to_retry = FCM.Notification.retry?(n) # Handle updated regids, remove bad ones, etc :unauthorized -&gt; # Bad FCM key error -&gt; # Some other error end end n = Pigeon.FCM.Notification.new(&quot;device token&quot;, %{}, %{&quot;message&quot; =&gt; &quot;test&quot;}) Pigeon.FCM.push(n, on_response: handler)","ref":"Pigeon.FCM.html#t:on_response/0","title":"Pigeon.FCM.on_response/0","type":"type"},{"doc":"Options for sending push notifications. :to - Defines worker to process push. Defaults to :fcm_default :on_response - Optional async callback triggered on receipt of push. See on_response/0 :timeout - Specifies timeout for push responses. Useful if sending large batches synchronously.","ref":"Pigeon.FCM.html#t:push_opts/0","title":"Pigeon.FCM.push_opts/0","type":"type"},{"doc":"FCM Configuration for Pigeon","ref":"Pigeon.FCM.Config.html","title":"Pigeon.FCM.Config","type":"module"},{"doc":"Returns a new FCM.Config with given opts. Examples iex&gt; Pigeon.FCM.Config.new( ...&gt; name: :test, ...&gt; key: &quot;fcm_key&quot;, ...&gt; uri: &#39;test.server.example.com&#39;, ...&gt; port: 5228 ...&gt; ) %Pigeon.FCM.Config{key: &quot;fcm_key&quot;, name: :test, port: 5228, uri: &#39;test.server.example.com&#39;}","ref":"Pigeon.FCM.Config.html#new/1","title":"Pigeon.FCM.Config.new/1","type":"function"},{"doc":"","ref":"Pigeon.FCM.Config.html#t:t/0","title":"Pigeon.FCM.Config.t/0","type":"type"},{"doc":"Defines FCM notification struct and convenience constructor functions.","ref":"Pigeon.FCM.Notification.html","title":"Pigeon.FCM.Notification","type":"module"},{"doc":"Creates FCM.Notification struct with device registration IDs and optional notification and data payloads. Examples iex&gt; Pigeon.FCM.Notification.new(&quot;reg ID&quot;) %Pigeon.FCM.Notification{ payload: %{}, registration_id: &quot;reg ID&quot;, priority: :normal } iex&gt; Pigeon.FCM.Notification.new(&quot;reg ID&quot;, %{&quot;body&quot; =&gt; &quot;test message&quot;}) %Pigeon.FCM.Notification{ payload: %{&quot;notification&quot; =&gt; %{&quot;body&quot; =&gt; &quot;test message&quot;}}, registration_id: &quot;reg ID&quot;, priority: :normal } iex&gt; Pigeon.FCM.Notification.new(&quot;reg ID&quot;, %{&quot;body&quot; =&gt; &quot;test message&quot;}, ...&gt; %{&quot;key&quot; =&gt; &quot;value&quot;}) %Pigeon.FCM.Notification{ payload: %{ &quot;data&quot; =&gt; %{&quot;key&quot; =&gt; &quot;value&quot;}, &quot;notification&quot; =&gt; %{&quot;body&quot; =&gt; &quot;test message&quot;} }, registration_id: &quot;reg ID&quot;, priority: :normal } iex&gt; regids = Enum.map(0..1_499, fn(_x) -&gt; &quot;reg ID&quot; end) iex&gt; [n1 | [n2]] = Pigeon.FCM.Notification.new(regids, ...&gt; %{&quot;body&quot; =&gt; &quot;test message&quot;}, %{&quot;key&quot; =&gt; &quot;value&quot;}) iex&gt; Enum.count(n1.registration_id) 1000 iex&gt; Enum.count(n2.registration_id) 500","ref":"Pigeon.FCM.Notification.html#new/3","title":"Pigeon.FCM.Notification.new/3","type":"function"},{"doc":"Updates &quot;collapse_key&quot; key. Examples iex&gt; put_collapse_key(%Pigeon.FCM.Notification{}, &quot;Updates available&quot;) %Pigeon.FCM.Notification{collapse_key: &quot;Updates available&quot;}","ref":"Pigeon.FCM.Notification.html#put_collapse_key/2","title":"Pigeon.FCM.Notification.put_collapse_key/2","type":"function"},{"doc":"Updates &quot;condition&quot; key. Supported condition: Topic, formatted as &quot;&#39;yourTopic&#39; in topics&quot;. This value is case-insensitive. Supported operators: &amp;&amp;, ||. Maximum two operators per topic message supported. Examples iex&gt; put_condition(%Pigeon.FCM.Notification{}, &quot;&#39;test&#39; in topics&quot;) %Pigeon.FCM.Notification{condition: &quot;&#39;test&#39; in topics&quot;}","ref":"Pigeon.FCM.Notification.html#put_condition/2","title":"Pigeon.FCM.Notification.put_condition/2","type":"function"},{"doc":"Updates &quot;content_available&quot; key. On iOS, use this field to represent content-available in the APNs payload. When a notification or message is sent and this is set to true, an inactive client app is awoken, and the message is sent through APNs as a silent notification and not through the FCM connection server. Note that silent notifications in APNs are not guaranteed to be delivered, and can depend on factors such as the user turning on Low Power Mode, force quitting the app, etc. On Android, data messages wake the app by default. On Chrome, currently not supported. Examples iex&gt; put_content_available(%Pigeon.FCM.Notification{}, true) %Pigeon.FCM.Notification{content_available: true}","ref":"Pigeon.FCM.Notification.html#put_content_available/2","title":"Pigeon.FCM.Notification.put_content_available/2","type":"function"},{"doc":"Updates &quot;data&quot; key in push payload. This parameter specifies the custom key-value pairs of the message&#39;s payload. For example, with data:{&quot;score&quot;:&quot;3x1&quot;}: On iOS, if the message is sent via APNs, it represents the custom data fields. If it is sent via FCM connection server, it would be represented as key value dictionary in AppDelegate application:didReceiveRemoteNotification:. On Android, this would result in an intent extra named score with the string value 3x1. The key should not be a reserved word (&quot;from&quot; or any word starting with &quot;google&quot; or &quot;gcm&quot;). Do not use any of the words defined in this table (such as collapse_key). Values in string types are recommended. You have to convert values in objects or other non-string data types (e.g., integers or booleans) to string. Examples iex&gt; put_data(%Pigeon.FCM.Notification{}, %{&quot;key&quot; =&gt; 1234}) %Pigeon.FCM.Notification{ payload: %{&quot;data&quot; =&gt; %{&quot;key&quot; =&gt; 1234}}, registration_id: nil }","ref":"Pigeon.FCM.Notification.html#put_data/2","title":"Pigeon.FCM.Notification.put_data/2","type":"function"},{"doc":"Sets &quot;dry_run&quot; key to true. This parameter, when set to true, allows developers to test a request without actually sending a message. The default value is false. Examples iex&gt; put_dry_run(%Pigeon.FCM.Notification{}) %Pigeon.FCM.Notification{dry_run: true}","ref":"Pigeon.FCM.Notification.html#put_dry_run/1","title":"Pigeon.FCM.Notification.put_dry_run/1","type":"function"},{"doc":"Updates &quot;mutable_content&quot; key. Currently for iOS 10+ devices only. On iOS, use this field to represent mutable-content in the APNs payload. When a notification is sent and this is set to true, the content of the notification can be modified before it is displayed, using a Notification Service app extension. This parameter will be ignored for Android and web. Examples iex&gt; put_mutable_content(%Pigeon.FCM.Notification{}, true) %Pigeon.FCM.Notification{mutable_content: true}","ref":"Pigeon.FCM.Notification.html#put_mutable_content/2","title":"Pigeon.FCM.Notification.put_mutable_content/2","type":"function"},{"doc":"Updates &quot;notification&quot; key in push payload. This parameter specifies the predefined, user-visible key-value pairs of the notification payload. See Notification payload support for detail. For more information about notification message and data message options, see Message types. If a notification payload is provided, or the content_available option is set to true for a message to an iOS device, the message is sent through APNs, otherwise it is sent through the FCM connection server. Examples iex&gt; put_notification(%Pigeon.FCM.Notification{}, ...&gt; %{&quot;body&quot; =&gt; &quot;message&quot;}) %Pigeon.FCM.Notification{ payload: %{&quot;notification&quot; =&gt; %{&quot;body&quot; =&gt; &quot;message&quot;}}, registration_id: nil }","ref":"Pigeon.FCM.Notification.html#put_notification/2","title":"Pigeon.FCM.Notification.put_notification/2","type":"function"},{"doc":"Updates &quot;priority&quot; key. Sets the priority of the message. Valid values are &quot;normal&quot; and &quot;high.&quot; On iOS, these correspond to APNs priorities 5 and 10. By default, notification messages are sent with high priority, and data messages are sent with normal priority. Normal priority optimizes the client app&#39;s battery consumption and should be used unless immediate delivery is required. For messages with normal priority, the app may receive the message with unspecified delay. When a message is sent with high priority, it is sent immediately, and the app can display a notification. Examples iex&gt; put_priority(%Pigeon.FCM.Notification{}, :normal) %Pigeon.FCM.Notification{priority: :normal} iex&gt; put_priority(%Pigeon.FCM.Notification{}, :high) %Pigeon.FCM.Notification{priority: :high} iex&gt; put_priority(%Pigeon.FCM.Notification{priority: :normal}, :bad) %Pigeon.FCM.Notification{priority: :normal}","ref":"Pigeon.FCM.Notification.html#put_priority/2","title":"Pigeon.FCM.Notification.put_priority/2","type":"function"},{"doc":"Updates &quot;restricted_package_name&quot; key. This parameter specifies the package name of the application where the registration tokens must match in order to receive the message. (Only affects android) Examples iex&gt; put_restricted_package_name(%Pigeon.FCM.Notification{}, &quot;com.example.app&quot;) %Pigeon.FCM.Notification{restricted_package_name: &quot;com.example.app&quot;}","ref":"Pigeon.FCM.Notification.html#put_restricted_package_name/2","title":"Pigeon.FCM.Notification.put_restricted_package_name/2","type":"function"},{"doc":"Updates &quot;time_to_live&quot; key. This parameter specifies how long (in seconds) the message should be kept in FCM storage if the device is offline. The maximum time to live supported is 4 weeks, and the default value is 4 weeks. For more information, see Setting the lifespan of a message. Examples iex&gt; put_time_to_live(%Pigeon.FCM.Notification{}, 60 * 60 * 24) %Pigeon.FCM.Notification{time_to_live: 86_400}","ref":"Pigeon.FCM.Notification.html#put_time_to_live/2","title":"Pigeon.FCM.Notification.put_time_to_live/2","type":"function"},{"doc":"Returns a list of registration IDs that should be removed Examples iex&gt; n = %Pigeon.FCM.Notification{response: [ ...&gt; {:success, &quot;regid1&quot;}, {:invalid_registration, &quot;regid2&quot;}, ...&gt; {:success, &quot;regid3&quot;}, {:update, {&quot;regid4&quot;, &quot;new_regid4&quot;}}, ...&gt; {:not_registered, &quot;regid5&quot;}, {:unavailable, &quot;regid6&quot;}]} iex&gt; remove?(n) [&quot;regid2&quot;, &quot;regid5&quot;]","ref":"Pigeon.FCM.Notification.html#remove?/1","title":"Pigeon.FCM.Notification.remove?/1","type":"function"},{"doc":"Returns a list of registration IDs that should be retried Examples iex&gt; n = %Pigeon.FCM.Notification{response: [ ...&gt; {:success, &quot;regid1&quot;}, {:invalid_registration, &quot;regid2&quot;}, ...&gt; {:success, &quot;regid3&quot;}, {:update, {&quot;regid4&quot;, &quot;new_regid4&quot;}}, ...&gt; {:not_registered, &quot;regid5&quot;}, {:unavailable, &quot;regid6&quot;}]} iex&gt; retry?(n) [&quot;regid6&quot;]","ref":"Pigeon.FCM.Notification.html#retry?/1","title":"Pigeon.FCM.Notification.retry?/1","type":"function"},{"doc":"Returns a list of successful registration IDs Examples iex&gt; n = %Pigeon.FCM.Notification{response: [ ...&gt; {:success, &quot;regid1&quot;}, {:invalid_registration, &quot;regid2&quot;}, ...&gt; {:success, &quot;regid3&quot;}, {:update, {&quot;regid4&quot;, &quot;new_regid4&quot;}}, ...&gt; {:not_registered, &quot;regid5&quot;}, {:unavailable, &quot;regid6&quot;}]} iex&gt; success?(n) [&quot;regid1&quot;, &quot;regid3&quot;]","ref":"Pigeon.FCM.Notification.html#success?/1","title":"Pigeon.FCM.Notification.success?/1","type":"function"},{"doc":"Returns a list of registration IDs and their corresponding new ID Examples iex&gt; n = %Pigeon.FCM.Notification{response: [ ...&gt; {:success, &quot;regid1&quot;}, {:invalid_registration, &quot;regid2&quot;}, ...&gt; {:success, &quot;regid3&quot;}, {:update, {&quot;regid4&quot;, &quot;new_regid4&quot;}}, ...&gt; {:not_registered, &quot;regid5&quot;}, {:unavailable, &quot;regid6&quot;}]} iex&gt; update?(n) [{&quot;regid4&quot;, &quot;new_regid4&quot;}]","ref":"Pigeon.FCM.Notification.html#update?/1","title":"Pigeon.FCM.Notification.update?/1","type":"function"},{"doc":"","ref":"Pigeon.FCM.Notification.html#t:regid_error_response/0","title":"Pigeon.FCM.Notification.regid_error_response/0","type":"type"},{"doc":"FCM push response for individual registration IDs {:success, &quot;reg_id&quot;} - Push was successfully sent {:update, {&quot;reg_id&quot;, &quot;new_reg_id&quot;}} - Push successful but user should use new registration ID for future pushes {regid_error_response, &quot;reg_id&quot;} - Push attempted but server responded with error","ref":"Pigeon.FCM.Notification.html#t:regid_response/0","title":"Pigeon.FCM.Notification.regid_response/0","type":"type"},{"doc":"Status of FCM request :success - Notification was processed successfully :timeout - Worker did not respond within timeout. This is likely an internal error :unauthorized - Bad FCM key :malformed_json - Push payload was invalid JSON :internal_server_error - FCM server encountered an error while trying to process the request :unavailable - FCM server couldn&#39;t process the request in time","ref":"Pigeon.FCM.Notification.html#t:status/0","title":"Pigeon.FCM.Notification.status/0","type":"type"},{"doc":"","ref":"Pigeon.FCM.Notification.html#t:t/0","title":"Pigeon.FCM.Notification.t/0","type":"type"},{"doc":"HTTP2 client adapter behaviour Uses Kadabra by default, but any client can be used with the appropriate adapter. Writing a Custom Client Adapter Pigeon.Worker relies on all of the callbacks for important connection functionality. start/0 Starts the client application when Pigeon starts. connect/3 Opens a socket connection. Must return {:ok, pid} or {:error, reason}. If an error, Pigeon.Worker will retry the callback two more times. send_ping/1 Sends an HTTP2 ping. Pigeon.Worker periodically sends pings to keep the connection alive. Client adapters must support pings for APNS-configured workers, though it is not necessary if only using FCM. send_request/3 Makes an HTTP2 request. Pigeon.Worker does not handle synchronous requests and will ignore the result of this callback. If the client is synchronous, the adapter will need to explicitly send a message back to the Pigeon.Worker. handle_end_stream/2 All incoming messages on the worker are passed through this callback. Must return {:ok, %Pigeon.Http2.Stream{...}} if it is a valid END_STREAM response for the adapter. All other messages are ignored. Example implementation for Kadabra if Code.ensure_loaded?(Kadabra) do defmodule Pigeon.Http2.Client.Kadabra do @moduledoc false @behaviour Pigeon.Http2.Client def start do Application.ensure_all_started(:kadabra) end def connect(uri, scheme, opts) do Kadabra.open(uri, scheme, opts) end def send_request(pid, headers, data) do Kadabra.request(pid, headers, data) end def send_ping(pid) do Kadabra.ping(pid) end def handle_end_stream({:end_stream, %{id: id, status: status, headers: headers, body: body}}, _state) do {:ok, %Pigeon.Http2.Stream{ id: id, status: status, headers: headers, body: body }} end def handle_end_stream(msg, _state), do: msg end end Using Your Client Adapter Once implemented, specify it in your config. Pigeon will use it for all HTTP2 connections. config :pigeon, http2_client: Pigeon.YourCustomAdapter","ref":"Pigeon.Http2.Client.html","title":"Pigeon.Http2.Client","type":"behaviour"},{"doc":"","ref":"Pigeon.Http2.Client.html#c:connect/3","title":"Pigeon.Http2.Client.connect/3","type":"callback"},{"doc":"Default http2 client to use. When not configured, defaults to Pigeon.Http2.Client.Kadabra Examples iex&gt; Pigeon.Http2.Client.default Pigeon.Http2.Client.Kadabra","ref":"Pigeon.Http2.Client.html#default/0","title":"Pigeon.Http2.Client.default/0","type":"function"},{"doc":"","ref":"Pigeon.Http2.Client.html#c:handle_end_stream/2","title":"Pigeon.Http2.Client.handle_end_stream/2","type":"callback"},{"doc":"","ref":"Pigeon.Http2.Client.html#c:send_ping/1","title":"Pigeon.Http2.Client.send_ping/1","type":"callback"},{"doc":"","ref":"Pigeon.Http2.Client.html#c:send_request/3","title":"Pigeon.Http2.Client.send_request/3","type":"callback"},{"doc":"","ref":"Pigeon.Http2.Client.html#c:start/0","title":"Pigeon.Http2.Client.start/0","type":"callback"},{"doc":"","ref":"Pigeon.Http2.Client.html#t:uri/0","title":"Pigeon.Http2.Client.uri/0","type":"type"},{"doc":"","ref":"Pigeon.ConfigError.html","title":"Pigeon.ConfigError","type":"exception"},{"doc":"HTTP2-compliant wrapper for sending iOS and Android push notifications.","ref":"getting-started.html","title":"Getting Started","type":"extras"},{"doc":"Add pigeon and kadabra as mix.exs dependencies: def deps do [ {:pigeon, &quot;~&gt; 1.6.1&quot;}, {:kadabra, &quot;~&gt; 0.6.0&quot;} ] end","ref":"getting-started.html#installation","title":"Getting Started - Installation","type":"extras"},{"doc":"Apple iOS (APNS) Add a default worker config to your mix config. See the detailed docs for setting up your certificate and key. config :pigeon, :apns, apns_default: %{ cert: &quot;cert.pem&quot;, key: &quot;key_unencrypted.pem&quot;, mode: :dev } This config sets up a default connection to APNS servers. cert and key can be any of the following: Static file path Full-text string of the file contents {:my_app, &quot;certs/cert.pem&quot;} (indicates path relative to the priv folder of the given application) Alternatively, you can use token based authentication: config :pigeon, :apns, apns_default: %{ key: &quot;AuthKey.p8&quot;, key_identifier: &quot;ABC1234567&quot;, team_id: &quot;DEF8901234&quot;, mode: :dev } :key - Created and downloaded via your developer account. Like :cert this can be a file path, file contents string or tuple :key_identifier - The 10-character key identifier associated with :key, obtained from your developer account :team_id - Your 10-character Team ID, obtained from your developer account Create a notification packet. Note: Your push topic is generally the app&#39;s bundle identifier. iex&gt; n = Pigeon.APNS.Notification.new(&quot;your message&quot;, &quot;your device token&quot;, &quot;your push topic (optional)&quot;) Send the packet. Pushes are synchronous and return the notification with an updated :response key. iex&gt; Pigeon.APNS.push(n) %Pigeon.APNS.Notification{device_token: &quot;your device token&quot;, expiration: nil, id: &quot;963B9FDA-EA60-E869-AAB5-9C88C8E7396B&quot;, payload: %{&quot;aps&quot; =&gt; %{&quot;alert&quot; =&gt; &quot;your message&quot;}}, response: :success, topic: &quot;your push topic&quot;} # Add an `:on_response` callback for async pushes. iex&gt; Pigeon.APNS.push(n, on_response: fn(x) -&gt; IO.inspect(x) end) :ok Additional documentation: APNS (Apple iOS) Android (FCM) Looking for GCM? Try v0.13 or earlier. Add a default worker config to your mix config. config :pigeon, :fcm, fcm_default: %{ key: &quot;your_fcm_key_here&quot; } Create a notification packet. FCM notifications support iex&gt; msg = %{ &quot;body&quot; =&gt; &quot;your message&quot; } iex&gt; n = Pigeon.FCM.Notification.new(&quot;your device registration ID&quot;, msg) Send the packet. Pushes are synchronous and return the notification with updated :status and :response keys. If :status is success, :response will contain a keyword list of individual registration ID responses. iex&gt; Pigeon.FCM.push(n) %Pigeon.FCM.Notification{message_id: &quot;0:1512580747839227%8911a9178911a917&quot;, payload: %{&quot;notification&quot; =&gt; %{&quot;body&quot; =&gt; &quot;your message&quot;}}, priority: :normal, registration_id: &quot;your device registration ID&quot;, response: [success: &quot;your device registration ID&quot;], status: :success} # Add an `:on_response` callback for async pushes. iex&gt; Pigeon.FCM.push(n, on_response: fn(x) -&gt; IO.inspect(x) end) :ok Additional documentation: FCM (Android) Amazon Android (ADM) Add a default worker config to your mix config. config :pigeon, :adm, adm_default: %{ client_id: &quot;your_oauth2_client_id_here&quot;, client_secret: &quot;your_oauth2_client_secret_here&quot; } Create a notification packet. iex&gt; msg = %{ &quot;body&quot; =&gt; &quot;your message&quot; } iex&gt; n = Pigeon.ADM.Notification.new(&quot;your device registration ID&quot;, msg) Send the packet. iex&gt; Pigeon.ADM.push(n) %Pigeon.ADM.Notification{consolidation_key: nil, expires_after: 604800, md5: &quot;M13RuG4uDWqajseQcCiyiw==&quot;, payload: %{&quot;data&quot; =&gt; %{&quot;body&quot; =&gt; &quot;your message&quot;}}, registration_id: &quot;your device registration ID&quot;, response: :success, updated_registration_id: nil} # Add an `:on_response` callback for async pushes. iex&gt; Pigeon.ADM.push(n, on_response: fn(x) -&gt; IO.inspect(x) end) :ok Additional documentation: ADM (Amazon Android)","ref":"getting-started.html#quickstart-guides","title":"Getting Started - Quickstart Guides","type":"extras"},{"doc":"Workers may be specified at application startup by creating a module containing functions that return zero or more configuration structures appropriate to the push service being enabled. Specify these in your config.exs as: config :pigeon, workers: [ {YourApp.Pigeon, :apns_config}, {YourApp.Pigeon, :fcm_config}, {YourApp.Pigeon, :adm_config} ] These should be implemented as: defmodule YourApp.Pigeon do @moduledoc false @push_mode if(Mix.env() == :production, do: :prod, else: :dev) def apns_config do Pigeon.APNS.ConfigParser.parse( key: System.get_env(&quot;APNS_KEY&quot;), key_identifier: System.get_env(&quot;APNS_KEY_ID&quot;), team_id: System.get_env(&quot;APNS_TEAM_ID&quot;), mode: @push_mode, name: :apns_default ) end def fcm_config do Pigeon.FCM.Config.new(name: :fcm_default, key: System.get_env(&quot;FCM_SERVER_KEY&quot;)) end end If your startup configuration requires reading your configuration from a database or using another dependency that needs a database, startup is a little more complex. Modify your mix.exs to not start pigeon by default: def deps do [ {:pigeon, &quot;~&gt; 1.3.1&quot;, runtime: false}, {:kadabra, &quot;~&gt; 0.4.4&quot;}, {:ecto, &quot;~&gt; 2.0 or ~&gt; 3.0&quot;} ] end Modify config.exs to specify a single worker function: config :pigeon, workers: [{YourApp.Pigeon, :config}] Modify your main application to start pigeon after your Repo has been started under your application’s supervision tree: def start(_type, _args) do children = [ YourApp.Repo, ] opts = [strategy: :one_for_one, name: YourApp.Supervisor] with {:ok, sup} &lt;- Supervisor.start_link(children, opts), {:ok, _} &lt;- Application.ensure_all_started(:pigeon, :permanent) do {:ok, sup} end end Implement your database query as part of your Pigeon module: defmodule YourApp.Pigeon do @moduledoc false alias YourApp.{PushApplication, Repo} def config_workers do PushApplication |&gt; Repo.all() |&gt; Enum.map(&amp;build_config/1) end defp build_config(%{type: &quot;apns&quot;} = config) Pigeon.APNS.ConfigParser.parse( key: config.key, key_identifier: config.key_identifier, team_id: config.team_id, mode: config.mode, name: Atom.to_string(config.name) # This is bad, but keep it simple! ) end defp build_config(%{type: &quot;fcm&quot;} = config) do Pigeon.FCM.Config.new( name: Atom.to_string(config.name), key: config.key ) end end","ref":"getting-started.html#startup-configuration-of-push-workers","title":"Getting Started - Startup Configuration of Push Workers","type":"extras"},{"doc":"APNS (Apple iOS)","ref":"apns-apple-ios.html","title":"APNS (Apple iOS)","type":"extras"},{"doc":"Set your environment variables. See below for setting up your certificate and key. config :pigeon, :apns, apns_default: %{ cert: &quot;cert.pem&quot;, key: &quot;key_unencrypted.pem&quot;, mode: :dev } This config sets up a default socket connection to send to APNS servers. cert and key can be any of the following: Static file path Full-text string of the file contents (useful for environment variables) {:my_app, &quot;certs/cert.pem&quot;} (indicates path relative to the priv folder of the given application) Alternatively, you can use token based authentication: config :pigeon, :apns, apns_default: %{ key: &quot;AuthKey.p8&quot;, key_identifier: &quot;ABC1234567&quot;, team_id: &quot;DEF8901234&quot;, mode: :dev } :key - Created and downloaded via your developer account. Like :cert this can be a file path, file contents string or tuple :key_identifier - The 10-character key identifier associated with :key, obtained from your developer account :team_id - Your 10-character Team ID, obtained from your developer account Create a notification packet. Note: Your push topic is generally the app&#39;s bundle identifier. n = Pigeon.APNS.Notification.new(&quot;your message&quot;, &quot;your device token&quot;, &quot;your push topic (optional)&quot;) Send the packet. Pushes are synchronous and return the notification with an updated :response key. Pigeon.APNS.push(n)","ref":"apns-apple-ios.html#usage","title":"APNS (Apple iOS) - Usage","type":"extras"},{"doc":"The contents of payload is what will be received on the iOS device. If updating this field directly, use strings for your keys. It is recommended to use the convenience functions defined in Notifications with Custom Data. expiration is a UNIX epoch date in seconds (UTC). Passing a value of 0 expires the notification immediately and Apple will not attempt to redeliver it. %Pigeon.APNS.Notification{ collapse_id: String.t() | nil, device_token: String.t() | nil, expiration: non_neg_integer | nil, id: String.t() | nil, payload: %{String.t() =&gt; String.t()}, response: atom, topic: String.t() | nil }","ref":"apns-apple-ios.html#notification-struct","title":"APNS (Apple iOS) - Notification Struct","type":"extras"},{"doc":"In Keychain Access, right-click your push certificate and select &quot;Export...&quot; Export the certificate as cert.p12 Click the dropdown arrow next to the certificate, right-click the private key and select &quot;Export...&quot; Export the private key as key.p12 From a shell, convert the certificate. openssl pkcs12 -clcerts -nokeys -out cert.pem -in cert.p12 Convert the key. Be sure to set a PEM pass phrase here. The pass phrase must be 4 or more characters in length or this will not work. You will need that pass phrase added here in order to remove it in the next step. openssl pkcs12 -nocerts -out key.pem -in key.p12 Remove the PEM pass phrase from the key. openssl rsa -in key.pem -out key_unencrypted.pem cert.pem and key_unencrypted.pem can now be used as the cert and key in Pigeon.push, respectively. Set them in your config.exs","ref":"apns-apple-ios.html#generating-your-certificate-and-key-pem","title":"APNS (Apple iOS) - Generating Your Certificate and Key .pem","type":"extras"},{"doc":"Notifications can contain additional information in payload. (e.g. setting badge counters or defining custom sounds) import Pigeon.APNS.Notification n = Pigeon.APNS.Notification.new(&quot;message&quot;, &quot;device token&quot;, &quot;push topic&quot;) |&gt; put_badge(5) |&gt; put_sound(&quot;default&quot;) |&gt; put_content_available |&gt; put_mutable_content |&gt; put_category(&quot;category&quot;) Using a more complex alert dictionary? n |&gt; put_alert(%{ &quot;title&quot; =&gt; &quot;alert title&quot;, &quot;body&quot; =&gt; &quot;alert body&quot; }) Define custom payload data like so: n |&gt; put_custom(%{&quot;your-custom-key&quot; =&gt; %{ &quot;custom-value&quot; =&gt; 500 }})","ref":"apns-apple-ios.html#notifications-with-custom-data","title":"APNS (Apple iOS) - Notifications with Custom Data","type":"extras"},{"doc":"Multiple APNS worker connections can be configured simultaneously. Useful for supporting multiple apps and/or certificates at once. config :pigeon, :apns, default: %{ cert: &quot;cert.pem&quot;, key: &quot;key_unencrypted.pem&quot;, mode: :dev }, custom_worker: %{ cert: &quot;another_cert.pem&quot;, key: &quot;another_key_unencrypted.pem&quot;, mode: :prod } Send pushes with a to option in your second parameter. n = Pigeon.APNS.Notification.new(&quot;message&quot;, &quot;device token&quot;, &quot;push topic&quot;) Pigeon.APNS.push(n, to: :custom_worker) You can also start connections manually. iex&gt; {:ok, pid} = Pigeon.APNS.start_connection(cert: &quot;cert.pem&quot;, ...&gt; key: &quot;key.pem&quot;, mode: :dev) iex&gt; Pigeon.APNS.push(notif, to: pid) iex&gt; Pigeon.APNS.start_connection(cert: &quot;cert.pem&quot;, key: &quot;key.pem&quot;, ...&gt; mode: :dev, name: :custom) iex&gt; Pigeon.APNS.push(notif, to: :custom)","ref":"apns-apple-ios.html#custom-worker-connections","title":"APNS (Apple iOS) - Custom Worker Connections","type":"extras"},{"doc":"Pass an on_response option with an anonymous function in your second parameter. n = Pigeon.APNS.Notification.new(&quot;message&quot;, &quot;device token&quot;, &quot;push topic&quot;) Pigeon.APNS.push(n, on_response: fn(x) -&gt; IO.inspect(x) end) Responses return a notification with an updated :response key. You could handle responses like so: handler = fn(%Pigeon.APNS.Notification{response: response}) -&gt; case response do :success -&gt; Logger.debug &quot;Push successful!&quot; :bad_device_token -&gt; Logger.error &quot;Bad device token!&quot; _error -&gt; Logger.error &quot;Some other error happened.&quot; end end n = Pigeon.APNS.Notification.new(&quot;message&quot;, &quot;device token&quot;, &quot;push topic&quot;) Pigeon.APNS.push(n, on_response: handler)","ref":"apns-apple-ios.html#asynchronous-pushing","title":"APNS (Apple iOS) - Asynchronous Pushing","type":"extras"},{"doc":"Taken from APNS Provider API ReasonDescription :bad_collapse_idThe collapse identifier exceeds the maximum allowed size :bad_device_tokenThe specified device token was bad. Verify that the request contains a valid token and that the token matches the environment. :bad_expiration_dateThe apns-expiration value is bad. :bad_message_idThe apns-id value is bad. :bad_priorityThe apns-priority value is bad. :bad_topicThe apns-topic was invalid. :device_token_not_for_topicThe device token does not match the specified topic. :duplicate_headersOne or more headers were repeated. :idle_timeoutIdle time out. :missing_device_tokenThe device token is not specified in the request :path. Verify that the :path header contains the device token. :missing_topicThe apns-topic header of the request was not specified and was required. The apns-topic header is mandatory when the client is connected using a certificate that supports multiple topics. :payload_emptyThe message payload was empty. :topic_disallowedPushing to this topic is not allowed. :bad_certificateThe certificate was bad. :bad_certificate_environmentThe client certificate was for the wrong environment. :expired_provider_tokenThe provider token is stale and a new token should be generated. :forbiddenThe specified action is not allowed. :invalid_provider_tokenThe provider token is not valid or the token signature could not be verified. :invalid_push_typeThe apns-push-type value is invalid. :missing_provider_tokenNo provider certificate was used to connect to APNs and Authorization header was missing or no provider token was specified. :bad_pathThe request contained a bad :path value. :method_not_allowedThe specified :method was not POST. :unregisteredThe device token is inactive for the specified topic. :payload_too_largeThe message payload was too large. The maximum payload size is 4096 bytes. :too_many_provider_token_updatesThe provider token is being updated too often. :too_many_requestsToo many requests were made consecutively to the same device token. :internal_server_errorAn internal server error occurred. :service_unavailableThe service is unavailable. :shutdownThe server is shutting down.","ref":"apns-apple-ios.html#error-responses","title":"APNS (Apple iOS) - Error Responses","type":"extras"},{"doc":"FCM (Android)","ref":"fcm-android.html","title":"FCM (Android)","type":"extras"},{"doc":"Set your environment variables. config :pigeon, :fcm, fcm_default: %{ key: &quot;your_fcm_key_here&quot; } Create a notification packet. msg = %{&quot;body&quot; =&gt; &quot;your message&quot;} n = Pigeon.FCM.Notification.new(&quot;your device registration ID&quot;, msg) Send the packet. Pushes are synchronous and return the notification with updated :status and :response keys. If :status is success, :response will contain a keyword list of individual registration ID responses. Pigeon.FCM.push(n)","ref":"fcm-android.html#usage","title":"FCM (Android) - Usage","type":"extras"},{"doc":"Pass in a list of registration IDs, as many as you want. msg = %{&quot;body&quot; =&gt; &quot;your message&quot;} n = Pigeon.FCM.Notification.new([&quot;first ID&quot;, &quot;second ID&quot;], msg)","ref":"fcm-android.html#sending-to-multiple-registration-ids","title":"FCM (Android) - Sending to Multiple Registration IDs","type":"extras"},{"doc":"%Pigeon.FCM.Notification{ collapse_key: nil | String.t(), dry_run: boolean, message_id: nil | String.t(), payload: %{...}, priority: :normal | :high, registration_id: String.t() | [String.t(), ...], response: [] | [{atom, String.t()}, ...], | atom, restricted_package_name: nil | String.t(), status: atom | nil, time_to_live: non_neg_integer }","ref":"fcm-android.html#notification-struct","title":"FCM (Android) - Notification Struct","type":"extras"},{"doc":"FCM accepts both notification and data keys in its JSON payload. Set them like so: notification = %{&quot;body&quot; =&gt; &quot;your message&quot;} data = %{&quot;key&quot; =&gt; &quot;value&quot;} Pigeon.FCM.Notification.new(&quot;registration ID&quot;, notification, data) or Pigeon.FCM.Notification.new(&quot;registration ID&quot;) |&gt; put_notification(%{&quot;body&quot; =&gt; &quot;your message&quot;}) |&gt; put_data(%{&quot;key&quot; =&gt; &quot;value&quot;})","ref":"fcm-android.html#notifications-with-custom-data","title":"FCM (Android) - Notifications with Custom Data","type":"extras"},{"doc":"Pass an optional anonymous function as your second parameter. data = %{message: &quot;your message&quot;} n = Pigeon.FCM.Notification.new(data, &quot;device registration ID&quot;) Pigeon.FCM.push(n, fn(x) -&gt; IO.inspect(x) end) {:ok, %Pigeon.FCM.Notification{...}} Reponses return the notification with an updated response. on_response = fn(n) -&gt; case n.status do :success -&gt; bad_regids = FCM.Notification.remove?(n) to_retry = FCM.Notification.retry?(n) # Handle updated regids, remove bad ones, etc :unauthorized -&gt; # Bad FCM key error -&gt; # Some other error end end data = %{message: &quot;your message&quot;} n = Pigeon.FCM.Notification.new(&quot;your device token&quot;, data) Pigeon.FCM.push(n, on_response: on_response)","ref":"fcm-android.html#handling-push-responses","title":"FCM (Android) - Handling Push Responses","type":"extras"},{"doc":"Slightly modified from FCM Server Reference ReasonDescription :missing_registrationMissing Registration Token :invalid_registrationInvalid Registration Token :not_registeredUnregistered Device :invalid_package_nameInvalid Package Name :authentication_errorAuthentication Error :mismatch_sender_idMismatched Sender :invalid_jsonInvalid JSON :message_too_bigMessage Too Big :invalid_data_keyInvalid Data Key :invalid_ttlInvalid Time to Live :unavailableTimeout :internal_server_errorInternal Server Error :device_message_rate_exceededMessage Rate Exceeded :topics_message_rate_exceededTopics Message Rate Exceeded :unknown_errorUnknown Error","ref":"fcm-android.html#error-responses","title":"FCM (Android) - Error Responses","type":"extras"},{"doc":"ADM (Amazon Android)","ref":"adm-amazon-android.html","title":"ADM (Amazon Android)","type":"extras"},{"doc":"Set your environment variables. config :pigeon, :adm, client_id: &quot;your_oauth2_client_id_here&quot;, client_secret: &quot;your_oauth2_client_secret_here&quot; Create a notification packet. msg = %{ &quot;body&quot; =&gt; &quot;your message&quot; } n = Pigeon.ADM.Notification.new(&quot;your device registration ID&quot;, msg) Send the packet. Pigeon.ADM.push(n)","ref":"adm-amazon-android.html#usage","title":"ADM (Amazon Android) - Usage","type":"extras"},{"doc":"Pass an optional anonymous function as your second parameter. data = %{ message: &quot;your message&quot; } n = Pigeon.ADM.Notification.new(&quot;device registration ID&quot;, data) Pigeon.ADM.push(n, on_response: fn(x) -&gt; IO.inspect(x) end) Responses return a notification with an updated :response key. You could handle responses like so: on_response_handler = fn(x) -&gt; case x.response do :success -&gt; # Push successful :ok :update -&gt; new_reg_id = x.updated_registration_id # Update the registration ID in the database :invalid_registration_id -&gt; # Remove the bad ID from the database :unregistered -&gt; # Remove the bad ID from the database error -&gt; # Handle other errors end end data = %{ message: &quot;your message&quot; } n = Pigeon.ADM.Notification.new(&quot;your registration id&quot;, data) Pigeon.ADM.push(n, on_response: on_response_handler)","ref":"adm-amazon-android.html#handling-push-responses","title":"ADM (Amazon Android) - Handling Push Responses","type":"extras"},{"doc":"Taken from Amazon Device Messaging docs ReasonDescription :invalid_registration_idInvalid Registration Token :invalid_dataBad format JSON data :invalid_consolidation_keyInvalid Consolidation Key :invalid_expirationInvalid expiresAfter value :invalid_checksumInvalid md5 value :invalid_typeInvalid Type header :unregisteredApp instance no longer available :access_token_expiredExpired OAuth access token :message_too_largeData size exceeds 6 KB :max_rate_exceededSee Retry-After response header :unknown_errorUnknown Error","ref":"adm-amazon-android.html#error-responses","title":"ADM (Amazon Android) - Error Responses","type":"extras"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Security Bump minimum Kadabra to 0.6.0. This is a critical security update for CA certificate validation.","ref":"changelog.html#v1-6-1","title":"Changelog - v1.6.1","type":"extras"},{"doc":"Added JSON library made configurable. For backwards compatability, Poison is still a required dependency. Override in your config.exs. config :pigeon, json_library: Jason Fixed Handle FCM single message_id&#39;s on topic pushes.","ref":"changelog.html#v1-6-0","title":"Changelog - v1.6.0","type":"extras"},{"doc":"Added APNS InvalidPushType error (#172). Fixed various typespecs (#170).","ref":"changelog.html#v1-5-1","title":"Changelog - v1.5.1","type":"extras"},{"doc":"Bumped minimum Elixir version to 1.6 Raise Pigeon.ConfigError when booting invalid config structs. See below for validated keys and error types. APNS.JWTConfig now validates key p8 content before connecting. Relaxed gen_stage dependency to allow ~&gt; 1.0 Validated config keys: ADM.Config - :client_id, :client_secret APNS.Config - :cert, :key APNS.JWTConfig - :team_id, :key, :key_identifier FCM.Config - :key Possible error values: {:error, {:invalid, value}} {:error, {:nofile, value}}","ref":"changelog.html#v1-5-0","title":"Changelog - v1.5.0","type":"extras"},{"doc":"apns-push-type header support for iOS 13. An additional :push_type key has been added to the APNS.Notification struct.","ref":"changelog.html#v1-4-0","title":"Changelog - v1.4.0","type":"extras"},{"doc":"Document workers configuration for run-time configuration of push workers. Modify run-time configuration of push workers so that multiple (or no) workers may be returned by the startup configuration.","ref":"changelog.html#v1-3-2","title":"Changelog - v1.3.2","type":"extras"},{"doc":"Joken dependency bumped to 2.1","ref":"changelog.html#v1-3-1","title":"Changelog - v1.3.1","type":"extras"},{"doc":"Support for FCM content_available, mutable_content, and condition keys Set priority of APNS notifications Joken dependency bumped to 2.0.1","ref":"changelog.html#v1-3-0","title":"Changelog - v1.3.0","type":"extras"},{"doc":"Fixed ADM handling of connection timeouts","ref":"changelog.html#v1-2-4","title":"Changelog - v1.2.4","type":"extras"},{"doc":"Fixed APNS, FCM and ADM error response parse crashes. Error responses not listed in the documentation are returned as :unknown_error","ref":"changelog.html#v1-2-3","title":"Changelog - v1.2.3","type":"extras"},{"doc":"Fixed APNS handling of notification expiration Added APNS support for collapse_id","ref":"changelog.html#v1-2-2","title":"Changelog - v1.2.2","type":"extras"},{"doc":"FCM notifications can now handle time_to_live, collapse_key, restricted_package_name and dry_run keys","ref":"changelog.html#v1-2-1","title":"Changelog - v1.2.1","type":"extras"},{"doc":"Support for APNS JWT configuration Bump kadabra dependency to v0.4.2","ref":"changelog.html#v1-2-0","title":"Changelog - v1.2.0","type":"extras"},{"doc":"Relax gen_stage dependency to ~&gt; 0.12 Bump kadabra dependency to v0.3.7","ref":"changelog.html#v1-1-6","title":"Changelog - v1.1.6","type":"extras"},{"doc":"Fix: relax httpoison dependency to allow 0.x or 1.0","ref":"changelog.html#v1-1-5","title":"Changelog - v1.1.5","type":"extras"},{"doc":"Fix: :on_response callbacks spawned as supervised task instead of running in the Worker process Fix: ADM token refresh failure returns updated notification instead of error tuple","ref":"changelog.html#v1-1-4","title":"Changelog - v1.1.4","type":"extras"},{"doc":"More robust FCM/APNS backpressure Bumped minimum Kadabra version to v0.3.6","ref":"changelog.html#v1-1-3","title":"Changelog - v1.1.3","type":"extras"},{"doc":"Auto-restart connections if max stream ID is reached FCM/APNS Workers now use GenStage to queue pending pushes Bumped minimum Kadabra version to v0.3.5","ref":"changelog.html#v1-1-2","title":"Changelog - v1.1.2","type":"extras"},{"doc":"Bumped minimum Kadabra version to v0.3.4","ref":"changelog.html#v1-1-1","title":"Changelog - v1.1.1","type":"extras"},{"doc":"Minimum requirements now Elixir v1.4 and OTP 19.2 (Kadabra bumped to v0.3.0) Startup worker configs. Create a functions that return config structs and specify them your config.exs with config :pigeon, workers: [ {YourApp.Pigeon, :apns_config}, {YourApp.Pigeon, :fcm_config}, {YourApp.Pigeon, :adm_config}, ... ] APNS APNS.Config.config/1 renamed to APNS.Config.new/1 APNS.push/2 tagged tuples done away with in favor of a :response key on the notification. Override push server endpoint with :uri option in APNS.Config.new/1 :use_2197 renamed to :port :uri config option for overriding push server endpoint :reconnect now false by default FCM NotificationResponse done away with in favor of a :response key on Notification Override push server endpoint with :uri and :port options in FCM.Config.new/1 :uri and :port config options for overriding push server endpoint ADM ADM.Config.config/1 renamed to ADM.Config.new/1 ADM.push/2 tagged tuples done away with in favor of a :response key on the notification. ADM.start_connection/1 and ADM.stop_connection/1 added","ref":"changelog.html#v1-1-0","title":"Changelog - v1.1.0","type":"extras"},{"doc":"Fix: removed connection pinging from FCM.Worker (:ping_period option left in FCM config to not break API)","ref":"changelog.html#v1-0-4","title":"Changelog - v1.0.4","type":"extras"},{"doc":"Fixed proper handling of large FCM push batches","ref":"changelog.html#v1-0-3","title":"Changelog - v1.0.3","type":"extras"},{"doc":"Fixed FCM infinite GOAWAY session_timed_out loop","ref":"changelog.html#v1-0-2","title":"Changelog - v1.0.2","type":"extras"},{"doc":"Configurable :ping_period for FCM connections","ref":"changelog.html#v1-0-1","title":"Changelog - v1.0.1","type":"extras"},{"doc":"GCM migrated to FCM API (http2) GCM modules renamed to FCM Set priority of FCM notifications APNSWorker and ADMWorker renamed to APNS.Worker and ADM.Worker Disable auto-reconnect for APNS workers with reconnect: false Removed Chatterbox http2 client adapter","ref":"changelog.html#v1-0-0","title":"Changelog - v1.0.0","type":"extras"},{"doc":"Configurable :ping_period for APNS connections","ref":"changelog.html#v0-13-0","title":"Changelog - v0.13.0","type":"extras"},{"doc":"Various chatterbox client adapter fixes","ref":"changelog.html#v0-12-1","title":"Changelog - v0.12.1","type":"extras"},{"doc":"Configurable Pigeon.Http2.Client. Currently supports kadabra and chatterbox kadabra bumped to v0.2.0","ref":"changelog.html#v0-12-0","title":"Changelog - V0.12.0","type":"extras"},{"doc":"APNS workers can be started and referenced with pids and/or atom names Fix: Push :name option renamed to :to Fix: GCM/ADM async pushes now use spawn/1 instead of Task.async/1","ref":"changelog.html#v0-11-0","title":"Changelog - v0.11.0","type":"extras"},{"doc":"Fix: cleaned up Elixir v1.4 warnings","ref":"changelog.html#v0-10-3","title":"Changelog - v0.10.3","type":"extras"},{"doc":"Fix: poison dependency version made optionally ~&gt; 2.0 or ~&gt; 3.0","ref":"changelog.html#v0-10-2","title":"Changelog - v0.10.2","type":"extras"},{"doc":"Fix: kadabra not started","ref":"changelog.html#v0-10-1","title":"Changelog - v0.10.1","type":"extras"},{"doc":"Migrated HTTP/2 client from chatterbox to kadabra Support for ADM (Amazon Android) push APNS pushes are now synchronous by default. For async pushes use the new on_response option. GCM and ADM will have it in the next major release. Bulk APNS pushing Handling of multiple APNS worker connections with different configs Re-implemented APNS socket pings to keep connections open :invalid_jSON corrected to :invalid_json","ref":"changelog.html#v0-10-0","title":"Changelog - v0.10.0","type":"extras"},{"doc":"Fixed GCM error response atom conversion","ref":"changelog.html#v0-9-2","title":"Changelog - v0.9.2","type":"extras"},{"doc":"Fixed :eaddrinuse error when restarting Pigeon too quickly with :apns_2197 enabled","ref":"changelog.html#v0-9-1","title":"Changelog - v0.9.1","type":"extras"},{"doc":"APNS topic made optional APNS put_mutable_content helper function added GCM can be configured on a per-push basis Updated to use Macro.underscore","ref":"changelog.html#v0-9-0","title":"Changelog - v0.9.0","type":"extras"},{"doc":"Implemented Chatterbox as APNS HTTP2 client APNS server responses now caught asynchronously GCM support for notification and data payload keys (Pigeon.GCM.Notification.new API changes)","ref":"changelog.html#v0-8-0","title":"Changelog - v0.8.0","type":"extras"},{"doc":"APNS cert/key configs can now either be a file path, full-text string, or {:your_app, &quot;path/to/file.pem&quot;} (which looks in the /priv directory of your app) Fixed APNSWorker crash on :ssl.send/2 timeout Better error-handling for invalid APNS configs","ref":"changelog.html#v0-7-0","title":"Changelog - v0.7.0","type":"extras"},{"doc":"Pigeon.APNS.Notification.new/3 returns %Pigeon.APNS.Notification{} struct Configure APNS to use SSL port 2197 with apns_2197: true in your config.exs Error feedback symbols converted from CamelCase to snake_case APNS expiration values supported with expiration key in %Pigeon.APNS.Notification{}","ref":"changelog.html#v0-6-0","title":"Changelog - v0.6.0","type":"extras"},{"doc":"Fixed bug where APNSWorker would hang up if SSL connection failed. Now retries the connection twice more before gracefully shutting down.","ref":"changelog.html#v0-5-2","title":"Changelog - v0.5.2","type":"extras"},{"doc":"GCM error responses return proper chunk of regstration IDs","ref":"changelog.html#v0-5-1","title":"Changelog - v0.5.1","type":"extras"},{"doc":"Pigeon.GCM.Notification.new/2 returns %Pigeon.GCM.Notification{} struct Multiple registration IDs allowed in Pigeon.GCM.push/2 Remove :gcm_worker","ref":"changelog.html#v0-5-0","title":"Changelog - v0.5.0","type":"extras"}]